'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');
var vanilla = require('./vanilla.js');
var useSyncExternalStoreWithSelector = require('./useSyncExternalStoreWithSelector.js');

function useStore(api, selector = api.getState, equalityFn) {
  const slice = useSyncExternalStoreWithSelector.useSyncExternalStoreWithSelector(api.subscribe, api.getState, selector, equalityFn);
  react.useDebugValue(slice);
  return slice;
}
const createImpl = (createState) => {
  const api = typeof createState === "function" ? vanilla.default(createState) : createState;
  const useBoundStore = (selector, equalityFn) => useStore(api, selector, equalityFn);
  Object.assign(useBoundStore, api);
  return useBoundStore;
};
const create = (createState) => createState ? createImpl(createState) : createImpl;

exports.default = create;
exports.useStore = useStore;
//# sourceMappingURL=react-zustand.js.map
