import deepEqual from 'fast-deep-equal';

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
const computedImpl = (f, compute) => (set, get, api) => {
  const computeAndMerge = (state) => {
    const fullComputedState = compute(__spreadValues({}, state));
    const newState = __spreadValues(__spreadValues({}, fullComputedState), state);
    for (const k of Object.keys(fullComputedState))
      if (!deepEqual(state[k], fullComputedState[k]))
        newState[k] = fullComputedState[k];
    return newState;
  };
  const setWithComputed = (update, replace) => {
    set((state) => {
      const updated = typeof update === "object" ? update : update(state);
      return computeAndMerge(__spreadValues(__spreadValues({}, state), updated));
    }, replace);
  };
  api.setState = setWithComputed;
  const st = f(setWithComputed, get, api);
  return Object.assign({}, st, compute(st));
};
const computed = computedImpl;

export { computed };
//# sourceMappingURL=computed.js.map
