import { useDebugValue } from 'react';
import createStore from './vanilla.js';
import { useSyncExternalStoreWithSelector } from './useSyncExternalStoreWithSelector.js';

function useStore(api, selector = api.getState, equalityFn) {
  const slice = useSyncExternalStoreWithSelector(api.subscribe, api.getState, selector, equalityFn);
  useDebugValue(slice);
  return slice;
}
const createImpl = (createState) => {
  const api = typeof createState === "function" ? createStore(createState) : createState;
  const useBoundStore = (selector, equalityFn) => useStore(api, selector, equalityFn);
  Object.assign(useBoundStore, api);
  return useBoundStore;
};
const create = (createState) => createState ? createImpl(createState) : createImpl;

export { create as default, useStore };
//# sourceMappingURL=react-zustand.js.map
