import { StateCreator, StoreApi, StoreMutatorIdentifier } from './vanilla';
type ComputedStateCreator = <T extends object, A extends object, Mps extends [StoreMutatorIdentifier, unknown][] = [], Mcs extends [StoreMutatorIdentifier, unknown][] = []>(f: StateCreator<T, [...Mps, ['chrisvander/zustand-computed', A]], Mcs>, compute: (state: T) => A) => StateCreator<T, Mps, [['chrisvander/zustand-computed', A], ...Mcs], T & A>;
type Write<T, U> = Omit<T, keyof U> & U;
type StoreCompute<T, A> = Write<StoreApi<T>, {
    getState: () => T & A;
    subscribe: (listener: (state: T & A, prevState: T & A) => void) => () => void;
}>;
type WithCompute<S, A> = S extends {
    getState: () => infer T;
} ? Write<S, StoreCompute<T, A>> : never;
declare module './vanilla' {
    interface StoreMutators<S, A> {
        'chrisvander/zustand-computed': WithCompute<S, A>;
    }
}
export declare const computed: ComputedStateCreator;
export {};
//# sourceMappingURL=computed.d.ts.map